//
//  HTMLAction.java
//  JHime
//
//  Created by 山下 弘隆 on 08/04/08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

import javax.swing.text.Document;

public final class HTMLAction {
	public static void genericAttribute(TextView view) {
		HTMLAttributeDialog dlg = new HTMLAttributeDialog(view);

		if (dlg.getResult()) {
			view.insert(dlg.getString());
		} else {
			view.getDocumentView().requestFocusInWindow();
		}
	}

	public static void genericHtml(TextView view, String command) {
		HTMLBasicDialog dlg = new HTMLBasicDialog(view);

		if (dlg.getResult()) {
			view.insert(dlg.getStringStart(), dlg.getStringEnd());
		} else {
			view.getDocumentView().requestFocusInWindow();
		}
	}

	public static void genericMetaMime(TextView view, String command) {
		HTMLMimeDialog dlg = new HTMLMimeDialog(view);

		if (dlg.getResult()) {
			view.insert(dlg.getString());
		} else {
			view.getDocumentView().requestFocusInWindow();
		}
	}

	public static void genericMeta(TextView view, String command) {
		HTMLMetaDialog dlg = new HTMLMetaDialog(view);

		if (dlg.getResult()) {
			view.insert(dlg.getString());
		} else {
			view.getDocumentView().requestFocusInWindow();
		}
	}

	public static void genericStyle(TextView view, String command) {
		HTMLStyleDialog dlg = new HTMLStyleDialog(view, command);

		if (dlg.getResult()) {
			if (command.equals("link")) {
				view.insert(dlg.getString());
			} else {
				view.insert(dlg.getStringStart(), dlg.getStringEnd());
			}
		} else {
			view.getDocumentView().requestFocusInWindow();
		}
	}

	public static void genericScript(TextView view, String command) {
		if (command.equals("script")) {
			HTMLScriptDialog dlg = new HTMLScriptDialog(view);
			if (dlg.getResult()) {
				view.insert(dlg.getStringStart(), dlg.getStringEnd());
			} else {
				view.getDocumentView().requestFocusInWindow();
			}
		} else {
			insertBlockTag(view, command, true, true);
		}
	}

	public static void genericBlockquote(TextView view, String command) {
		HTMLBlockquoteDialog dlg = new HTMLBlockquoteDialog(view);
		if (dlg.getResult()) {
			view.insert(dlg.getStringStart(), dlg.getStringEnd());
		} else {
			view.getDocumentView().requestFocusInWindow();
		}
	}

	public static void genericInsDel(TextView view, String command) {
		HTMLInsDelDialog dlg = new HTMLInsDelDialog(view, command);
		if (dlg.getResult()) {
			view.insert(dlg.getStringStart(), dlg.getStringEnd());
		} else {
			view.getDocumentView().requestFocusInWindow();
		}
	}

	public static void genericTable(TextView view, String command) {
		HTMLTableDialog dlg = new HTMLTableDialog(view);
		if (dlg.getResult()) {
			view.insert(dlg.getStringStart(), dlg.getStringEnd());
		} else {
			view.getDocumentView().requestFocusInWindow();
		}
	}

	public static void genericTableCell(TextView view, String command) {
		HTMLTableCellDialog dlg = new HTMLTableCellDialog(view, command);
		if (dlg.getResult()) {
			view.insert(dlg.getStringStart(), dlg.getStringEnd());
		} else {
			view.getDocumentView().requestFocusInWindow();
		}
	}

	public static void genericA(TextView view, String command) {
		HTMLADialog dlg = new HTMLADialog(view);
		if (dlg.getResult()) {
			view.insert(dlg.getStringStart(), dlg.getStringEnd());
		} else {
			view.getDocumentView().requestFocusInWindow();
		}
	}

	public static void genericImg(TextView view, String command) {
		HTMLImgDialog dlg = new HTMLImgDialog(view);
		if (dlg.getResult()) {
			view.insert(dlg.getString());
		} else {
			view.getDocumentView().requestFocusInWindow();
		}
	}

	public static void genericObject(TextView view, String command) {
		HTMLObjectDialog dlg = new HTMLObjectDialog(view);
		if (dlg.getResult()) {
			view.insert(dlg.getStringStart(), dlg.getStringEnd());
		} else {
			view.getDocumentView().requestFocusInWindow();
		}
	}

	public static void genericParam(TextView view, String command) {
		HTMLParamDialog dlg = new HTMLParamDialog(view);
		if (dlg.getResult()) {
			view.insert(dlg.getString());
		} else {
			view.getDocumentView().requestFocusInWindow();
		}
	}

	public static void genericForm(TextView view, String command) {
		HTMLFormDialog dlg = new HTMLFormDialog(view);
		if (dlg.getResult()) {
			view.insert(dlg.getStringStart(), dlg.getStringEnd());
		} else {
			view.getDocumentView().requestFocusInWindow();
		}
	}

	public static void genericInput(TextView view, String command) {
		if (!command.equals("textarea")) {
			HTMLInputDialog dlg = new HTMLInputDialog(view, command);
			if (dlg.getResult()) {
				view.insert(dlg.getString());
			} else {
				view.getDocumentView().requestFocusInWindow();
			}
		} else {
			HTMLTextAreaDialog dlg = new HTMLTextAreaDialog(view);
			if (dlg.getResult()) {
				view.insert(dlg.getStringStart(), dlg.getStringEnd());
			} else {
				view.getDocumentView().requestFocusInWindow();
			}
		}
	}

	public static void genericSelectOption(TextView view, String command) {
		HTMLDialog dlg;
		if (command.equals("select")) {
			dlg = new HTMLSelectDialog(view);
		} else {
			dlg = new HTMLOptionDialog(view);
		}
		if (dlg.getResult()) {
			view.insert(dlg.getStringStart(), dlg.getStringEnd());
		} else {
			view.getDocumentView().requestFocusInWindow();
		}
	}

	public static void genericLabel(TextView view) {
		HTMLLabelDialog dlg = new HTMLLabelDialog(view);
		if (dlg.getResult()) {
			view.insert(dlg.getStringStart(), dlg.getStringEnd());
		} else {
			view.getDocumentView().requestFocusInWindow();
		}
	}

	public static void genericFormGroup(TextView view, String command) {
		if (command.equals("fieldset")) {
			insertBlockTag(view, command, true, true);
		} else {
			insertBlockTag(view, command, false, false);
		}
	}

	public static void insertBlockTag(TextView view, String tagName, boolean startBr, boolean endBr) {
		String startTag = "<" + tagName + ">";
		String endTag   = "</" + tagName + ">";

		if (startBr) {
			startTag = startTag + "\n";
		}
		if (endBr) {
			endTag   = endTag + "\n";
		}
		view.insert(startTag, endTag);
	}

	public static void insertSimpleTag(TextView view, String tagName, boolean endBr) {
		String tag = "<" + tagName + " />";

		if (endBr) {
			tag   = tag + "\n";
		}
		view.insert(tag);
	}
}
